#ifndef FLOOR_H
#define FLOOR_H

struct tileset;
class sdl;

#include <vector>
#include <string>

struct floor {
    std::vector<unsigned int> tiles;
    unsigned int w;
    unsigned int h;

    floor(unsigned int w, unsigned int h);
    void set(unsigned int x, unsigned int y, unsigned int id);
    unsigned int get(unsigned int x, unsigned int y);
    void load(std::string filename);
    void fill(unsigned int id);
    void fill(int left, int top, int right, int bot, unsigned int id);
    void fill_rand(int left, int top, int right, int bot);
    void fill_path(int left, int top, int right, int bot);
    void fill_wall(int left, int top, int right, int bot);
    void soften();
    void draw(class sdl * sdl, struct tileset * tileset);
    void draw(class sdl * sdl, struct tileset * tileset, int x_shift, int y_shift);
};

#endif // FLOOR_H
