#include "object.h"

#include "sdl.h"
#include "tileset.h"
#include "floor.h"
#include "sprite.h"

object::object(unsigned int tile_id, unsigned int x, unsigned int y) :
    x(x),
    y(y),
    anim_step(0)
{
    this->enqueue_anim(tile_id);
}

void object::enqueue_anim(unsigned int tile_id) {
    this->tiles.push_back(tile_id);
}

void object::draw(class sdl * sdl, struct tileset * tileset) {
    this->draw(sdl, tileset, 0, 0);
}

void object::draw(class sdl * sdl, struct tileset * tileset, int x_shift, int y_shift) {
    struct sprite * sprite = tileset->get(this->tiles.at(this->anim_step));
    sprite->draw(sdl, this->x * sprite->w + x_shift, this->y * sprite->h + y_shift);
}
