#include "portal.h"

#include "sdl.h"
#include "tileset.h"
#include "chara.h"
#include "sprite.h"

struct tileset * portal::anim = NULL;

portal::portal(
    class sdl * sdl,
    int x, int y,
    unsigned int end_a,
    unsigned int end_b
) :
    x(x),
    y(y),
    end_a(end_a),
    end_b(end_b),
    step(0)
{
    if(portal::anim == NULL) {
        portal::anim = new tileset(sdl, "data\\portal.bmp", 20);
    }
}

portal::~portal() {
    if(portal::anim != NULL) {
        delete(portal::anim);
        portal::anim = NULL;
    }
}

void portal::draw(class sdl * sdl, unsigned int world_id) {
    this->draw(sdl, 0, 0, world_id);
}

void portal::draw(class sdl * sdl, int x_shift, int y_shift, unsigned int world_id) {
    this->step = (this->step+1)%portal::anim_period;
    if(world_id == this->end_a || world_id == this->end_b) {
        struct sprite * sprite = portal::anim->get(this->step*portal::anim->tiles.size()/portal::anim_period);
        sprite->draw(sdl, this->x * sprite->w + x_shift, this->y * sprite->h + y_shift);
    }
}

void portal::step_on(int player_x, int player_y, unsigned int * world_id) {
    if(player_x == this->x && player_y == this->y) {
        if(*world_id == this->end_a) {
            *world_id = this->end_b;
        } else if(*world_id == this->end_b) {
            *world_id = this->end_a;
        }
    }
}
