#ifndef SDL_H
#define SDL_H

class sprite;

#include <SDL2/SDL.h>
#include <string>
#include <list>
#include <map>

class sdl {
public:
    SDL_Window * window;
    SDL_Renderer * renderer;
    const Uint8 * keyboard;
    int max_key;
    int width;
    int height;

    sdl(int width, int height);
    ~sdl();
    void error(std::string message);
    void set_icon(std::string filename);
    void set_title(std::string title);
    void next_frame();
    bool key(SDL_Scancode key);
    bool keydown(SDL_Scancode key);
    void load_sprite(std::string sprite_name, std::string file_name);
    class sprite * get_sprite(std::string name);

private:
    std::list<SDL_Scancode> scancodes;
    std::map<std::string, class sprite *> sprites;
    sdl(const sdl&);
    class sdl & operator=(const sdl&);
};

#endif // SDL_H
