#ifndef TILESET_H
#define TILESET_H

struct sprite;
class sdl;

#include <string>
#include <vector>

struct tileset {
    std::vector<struct sprite *> tiles;

    tileset(class sdl * sdl, std::string filename, unsigned int tile_size);
    ~tileset();
    struct sprite * get(unsigned int index);
};

enum tile_type {
// Row 1
    palette_a = 0,
    palette_b,
    mosaic_a,
    mosaic_b,
    mosaic_c,
    mosaic_broken,
    mosaic_white,
    mosaic_black,
// Row 2
    soil_a,
    soil_b,
    path_toplft,
    path_top,
    path_toprgt,
    path_vertical,
    path_horizontal,
    path_lone,
// Row 3
    soil_c,
    soil_d,
    path_lft,
    path,
    path_rgt,
    path_endtop,
    path_endlft,
    path_endrgt,
// Row 4
    path_rare_a,
    path_rare_b,
    path_botlft,
    path_bot,
    path_botrgt,
    path_endbot,
    soil_2x1_lft,
    soil_2x1_rgt,
// Row 5
    pillar_top,
    wall_toplft,
    wall_top,
    wall_toprgt,
    wall_top_vertical,
    wall_top_roof,
    wall_top_round,
    wall_top_undef,
// Row 6
    pillar,
    wall_lft,
    wall,
    wall_rgt,
    wall_alt_a,
    wall_alt_b,
    wall_special,
    wall_undef,
// Row 7
    pillar_bot,
    wall_botlft,
    wall_bot,
    wall_botrgt,
    wall_bot_alt_a,
    wall_bot_alt_b,
    wall_bot_special,
    wall_bot_undef,
// Row 8
    block_a,
    block_b,
    big1_toplft,
    big1_toprgt,
    big2_toplft,
    big2_toprgt,
    big3_toplft,
    big3_toprgt,
// Row 9
    bigblock_toplft,
    bigblock_toprgt,
    big1_midlft,
    big1_midrgt,
    big2_midlft,
    big2_midrgt,
    big3_midlft,
    big3_midrgt,
// Row 10
    bigblock_botlft,
    bigblock_botrgt,
    big1_botlft,
    big1_botrgt,
    big2_botlft,
    big2_botrgt,
    big3_botlft,
    big3_botrgt,
// end
    tile_end
};

#endif // TILESET_H
